#include<iostream>
#include <fstream>
#include<cstdio>
#include<climits>
#include <stdlib.h>
using namespace std;
FILE *fin=fopen("mirror.in","r");
ofstream fout("mirror.out");

int v[1000005],n,ct,k;
int w[33];

int cautare_binara(int x)
{
    int st=1,dr=31,mij;
    if(x>=w[31])
        return w[31];
    if(x<=w[1])
        return w[1];
    while(st<=dr)
    {
        mij=(st+dr)>>1;
        if(w[mij]==x)
            return x;
        if(x>w[mij]&&x<=w[mij+1])
            return w[mij+1];
        if(x<w[mij])
            dr=mij-1;
        else
            st=mij+1;
    }
    return -1;
}

int transforma(int x)
{
    int y=cautare_binara(x);
    y=(x^y);
    return y;
}

void rezolva1()
{
    int masca=0,i,j,y=1<<k-1,nr,x=0;
    for(i=1; i<=n; i++)
    {
        nr=v[i];
        if(masca==0)
            masca=1;
        while(masca<nr)
            masca<<=1;
        if(masca>nr)masca>>=1;
        while(masca)
        {
            if(masca&nr)
                x=x+y;
            y/=2;
            if(y==0)
            {
                fout<<x<<" ";
                y=1<<k-1;
                x=0;
            }
            masca>>=1;
        }
    }
    fout<<'\n';
}
int lungime(int &st, int &dr)
{
    int ok,l,lmax=0,masca=1,ddr,i;
    do
    {
        ok=0;//pp ca nu mai sunt cifre binare de 1
        l=0;
        for(i=st; i<=dr; i++)
        {
            if(masca<=v[i])
                ok=1;
            if(masca&v[i])
                l++;
            else
            {
                if(l>lmax)
                {
                    lmax=l;
                    ddr=i-1;
                }
                l=0;
            }
        }
        if(l>lmax)
            {
                lmax=l;
                ddr=dr;
            }
        masca<<=1;
    }
    while(ok==1);
    dr=ddr;
    st=ddr-lmax+1;
    return lmax;
}

void secventa()
{
    int st=0,dr=0,i,lung,lmax=0,sst,ddr;
    i=1;
    while(v[i]==0&&i<=n)
        i++;
    if(i<=n)
        for( ; i<=n; i++)
            if(v[i]!=0)
                if(st==0)
                    st=dr=i;
                else
                    dr++;
            else
            {
                if(st)
                {
                    lung=lungime(st,dr);
                    if(lung>lmax)
                    {
                        lmax=lung;
                        sst=st;
                        ddr=dr;
                    }
                    st=0;
                }
            }
    if(dr)
    {
        lung=lungime(st,dr);
        if(lung>lmax)
        {
            lmax=lung;
            sst=st;
            ddr=dr;
        }
    }
    fout<<lmax<<'\n'<<sst<<" "<<ddr<<'\n';
}

int main()
{
    int x=1,i,j,masca;
    for(i=1; i<=31; i++)
    {
        x=x<<1;
        w[i]=x-1;
    }
    fscanf(fin,"%d%d%d",&ct,&n,&k);
    for(i=1; i<=n; i++)
        fscanf(fin,"%d",&v[i]);

    if(ct==1)
    {
        rezolva1();
        return 0;
    }
    //transformare cu cautare binara- timp mai mare?
    for(i=1; i<=n; i++)
    {
        for(j=1; j<=k&&v[i]; j++)
            v[i]=transforma(v[i]);
        //  fout<<v[i]<<" ";
    }

    secventa();
    return 0;
}
