#include <iostream>
#include <fstream>

using namespace std;

ifstream in("bomboane.in");
ofstream out("bomboane.out");

int n,p,a[10002],i,k;

int cmmdc(int a, int b){
    int r;
    while(b > 0){
        r = a % b;
        a = b;
        b = r;
    }
    return a;
}

int nr_max_col(int n)
{
  //determinam valoarea maxima pentru k, a.i k * (k + 1) / 2 <= n
  int k;
  for (k = 1; ; k++)
    if (k * (k + 1) / 2 > n)
      return k-1;
}

int main()
{
    in >> p >> n;
    for(i = 1; i <= n; i++) in >> a[i];

    if(p == 1){
        int vmin = a[1];
        //determinam vmin = min(a[1], a[2] ... a[n])
        for(i = 1; i <= n; i++)
            if(vmin > a[i]) vmin = a[i];

        //scadem vmin din elementele vectorului a
        for(i = 1; i <= n; i++) a[i] = a[i] - vmin;

        //dereminam k = cmmdc(a[1], a[2] ... a[n])
        k = 0;
        for(i = 1; i <= n; i++)
            k = cmmdc(a[i], k);

        out << k;
    }
    else {
        int l, r;
        for(i = 1; i <= n; i++){
            k = nr_max_col(a[i]);//determinam valoarea maxima pentru k, a.i k * (k + 1) / 2 <= a[i]

            out << k << " ";
            //cea mai simpla modalitate este sa se afiseze 1 k 2 k-1 3 k-2 etc
            //la afisarea primei prechi trebuie avut in vedere ca daca k * (k + 1) < n
            //atunci se afiseaza 1 si k + diferenta (a[i] - k * (k+1) / 2
            l = 1; r = k;//se porneste cu 2 indici l = 1 si r = k si se afiseaza alternativ
            //dupa fiecare afisare l creste, iar r scade
            while(l <= r){
                if(l != r) {
                        out << l << " ";
                        if(r == k) out << r + a[i] - k * (k+1) / 2<< " ";
                        else out << r << " ";
                }
                else out << l << " ";
                l = l + 1;
                r = r - 1;
            }
            out << "\n";
        }
    }

    return 0;
}
